import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.*;
	public class CanvasMouseListener implements MouseListener ,MouseMotionListener {
		public Canvas canvas = null;
		public Graphics g = null;
		public int maxX = 0;
		public int maxY = 0;
		public int lastX = 0;
		public int lastY = 0;
		CanvasMouseListener (Canvas e) {
			canvas = e;
			maxX = canvas.getWidth();
			maxY = canvas.getHeight();
			g = canvas.getGraphics();
		}
		public void mousePressed(MouseEvent e) {
			
			lastX = e.getX();
			lastY = e.getY();
			draw_line(e);  
		}
		public void mouseReleased(MouseEvent e) {
		}
		public void mouseEntered(MouseEvent e) {
		}
		public void mouseExited(MouseEvent e) {
	
		}
		public void mouseClicked(MouseEvent e) {
		draw_line(e);  
	
	}
   public void mouseMoved(MouseEvent e) {
            }

   public void mouseDragged(MouseEvent e) {
		draw_line(e);  
   }
	public void draw_line(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();
		int minx = x;
		int maxx = x;
		int starty = y;
		int endy = y;
		int tmp = 0;
		g = canvas.getGraphics();
		g.setColor(Color.black);
		g.drawLine(x,y,x,maxY-1);
		g.setColor(Color.white);
		g.drawLine(x,y,x,0);
		if (x > lastX) {
			minx = lastX;
			starty = lastY;
		} else {
			maxx = lastX;
			endy = lastY;
		}
			int rise = endy - starty;
			int _run = maxx - minx;
			double slope = (rise / (1.0*_run));
			for (int i = minx; i < maxx; i++) {
				int run = maxx - minx;
				if (run == 0) {
					break;
				}
				tmp = new Double(slope*(i-minx)+starty).intValue();
			g.setColor(Color.black);
			g.drawLine(i,tmp,i,maxY-1);
			g.setColor(Color.white);
			g.drawLine(i,tmp,i,0);
				
				
			}
		
		lastX = x;
		lastY = y;
	}

}

		
