import java.awt.*;
import java.awt.event.*;
//think about inheriting canvas?
public class Enveloper extends Canvas {
	private int [] data = null;
	public int size = 0;
	public int maxX = 0;
	public int maxY = 0;
	public int lastX = 0;
	public int lastY = 0;
	public int init_called = 0;
//	public Canvas canvas = null;
/*	Enveloper (int x, int y) {
		canvas = new Canvas;
		canvas.setSize(400,100);
		canvas.setBackground(Color.white);
		init();
	}
	Enveloper(Canvas can_vas) {
		canvas = can_vas;
		init()
	}*/
	Enveloper() {
		super();	
		setSize(400,100);
		init();
	}
	Enveloper(int x,int y) {
		super();	
		setSize(x,y);
		init();
	}
	private void init_called() {
		if (init_called > 0) {
			init_called = 1;
			init();
		}
	}
	private void init() {
		size = getWidth();
		//size = canvas.getWidth();
		maxX = size;
	//	maxY = canvas.getHeight();
		maxY = getHeight();
		data = new int[size];
	 	EnveloperMouseListener cml = new EnveloperMouseListener(this);
    	//canvas.addMouseListener(cml);
    	//canvas.addMouseMotionListener(cml);
    	addMouseListener(cml);
    	addMouseMotionListener(cml);
		for (int i = 0; i < size; i++) {
			data[i] = -1; //negative means not used yet (to be skipped!)
		}
		data[0] = data[size-1] = 0;
	}
	
	public void set(int x,int y) {
		if (x >= 0 && x < size) {
			data[x] = y;
		}
	}
//	public Canvas getCanvas() {
//		return canvas;
//	}
	public int get (int x) {
		if (data[x] > -1) {
			return data[x];
		} else {
			//find front
			int front = -1;
			int frontval = -1;
			int back = -1;
			int backval = -1;
			for (int k = x; k < size; k++) {
				if (data[k] > -1) {
					front = k;
					frontval = data[k];
					break;
				}
			}
			if (front == -1) {
				front=size;
				frontval=0;
			}
			for (int k = x; k > -1; k--) {
				if (data[k] > -1) {
					back = k;
					backval = data[k];
					break;
				}
			}
			if (back == -1) {
				back=0;
				backval=0;
			}
			//Now we have front and back we need to interpolate!
			double slope = (frontval - backval)/(1.0*(front-back));
			return new Double(slope*(x-back)+backval).intValue();

		}
	}
	public void paint(Graphics g) {
		draw_env(g);
	}
	public void repaint(Graphics g) {
		draw_env(g);
	}
	public void draw_env() {
		//this.draw(canvas.getGraphics());
		this.draw_env(getGraphics());
	}
	public void draw_env(Graphics g) {
		int x = 0;
		int y = 0;
		for (int i = 0; i < size; i++) {
			y = maxY - 1 - this.get(i);
			g.setColor(Color.black);
			g.drawLine(i,y,i,maxY-1);
			if (i%100 == 0) {
				g.setColor(Color.blue);
			} else if (i%25 == 0) {
				g.setColor(Color.red);
			} else {
				g.setColor(Color.white);
			}
			g.drawLine(i,y,i,0);
			
		}
		
	}
/*	public int getWidth() {
		return canvas.getWidth();
	}
	public int getHeight() {
		return canvas.getHeight();
	}*/
	public Dimension getMinimumSize() {
		return new Dimension(10,10);
	}
	public Dimension getPreferredSize() {
		return new Dimension(400,100);
	}
	public void zero() {
		for (int i = 0; i < size; i++) {
			data[i]=-1;
		}
		data[0] = data[size-1] = 0;
	}
	public String toPerl (String name) {
		String out = "@" + name + " = ( ";
		for (int i = 0; i < size; i++) {
			if (data[i] != -1) {
				out = (out + "\n" + "[" + (double)(i/((double)(size))) + "," + (double)(data[i]/((double)(maxY))) + "],");
			}
		}
		out = out + "\n);\n";
		return out;
	}
}
